#!/usr/bin/env python

# creates a bookmarks view

import pygtk
pygtk.require('2.0')
import gtk
import gobject 

import readconfig
import dialog
import handlers
import mainwindow

class Bookmarks_Widget:
    
    def instance(self):
        return self
    
    def menuaction_handler_scan(self, parm1):
        handlers.scan(self, self.mainwindow)
		
    def menuaction_handler_umount(self, parm1):
        self.mainwindow.umount()

    def menuaction_handler_mount(self, parm1):
        handlers.mount(self, self.mainwindow)
		
    def menuaction_handler_filemngr(self, parm1):
        handlers.filemanager(self, self.mainwindow)

    def menuaction_handler_remove(self, parm1):
        handlers.remove(self, self.mainwindow)

    def widget_popup(self, type, mounted):
        popup = gtk.Menu()
        separator = gtk.SeparatorMenuItem()
        if type == "host_menu":
            item1 = gtk.ImageMenuItem("SCAN")
            item1.connect("activate", self.menuaction_handler_scan)
            item2 = gtk.ImageMenuItem(gtk.STOCK_REMOVE)
            item2.connect("activate", self.menuaction_handler_remove)
            popup.append(item1)
            popup.append(item2)
        if type == "share_menu":
            if mounted == False:
                item1 = gtk.ImageMenuItem("UNMOUNT")
                item1.connect("activate", self.menuaction_handler_umount)
                item2 = gtk.ImageMenuItem("FILEMANAGER")
                item2.connect("activate", self.menuaction_handler_filemngr)
                popup.append(item1)
                popup.append(item2)
            else:
                item1 = gtk.ImageMenuItem("MOUNT")
                item1.connect("activate", self.menuaction_handler_mount)
                popup.append(item1)
        menu = popup
        return menu

    def select_on_click(self, treeview):
        treestore = treeview.get_selection()
        (model, iter) = treestore.get_selected()
        if self.if_popup == 1:
            if model.iter_parent(iter) == None:
                menu = self.widget_popup("host_menu", False)
            else:
                mountpoint = model.get_value(iter, 3)
                if mountpoint == '':
                    menu = self.widget_popup("share_menu", True)
                else:
                    menu = self.widget_popup("share_menu", False)

            menu.popup(None, None, None, 3, gtk.get_current_event_time())
            menu.show_all()
            self.if_popup = 0

    def button_clicked(self, widget, event):
        if event.type == gtk.gdk._2BUTTON_PRESS and event.button == 1:
            treeselection = self.treeview.get_selection()
            (model, iter) = treeselection.get_selected()
            if iter != None:
                path = model.get_path(iter)
                column = self.treeview.get_column(0)
                if model.iter_parent(iter) == None:
                    handlers.scan(self, self.mainwindow)
                else:
                    handlers.mount(self, self.mainwindow)
        if event.type == gtk.gdk.BUTTON_PRESS and event.button == 3:
            self.if_popup = 1

    def Bookmarks(self):
        # bookmarks
        self.column_names = ['Name', 'Comment', 'Mountpoint']
        
        # if 1, menu pops up
        self.if_popup = 0

        # we'll add some data now - a list of our hosts
        self.hostlist = readconfig.readconfig()
        c = 0
        self.piter = []
        for parent in self.hostlist:
            iter = self.treestore.append(None, [ self.hostlist[c], 'host', "", ""])
            self.treestore.set(iter, 2, '')
            c = c + 1

        # create the TreeView using treestore
        tvcolumn = [None] * len(self.column_names)

        # create 3 TreeViewColumns to display the data
        cell = gtk.CellRendererText()
        cell1 = gtk.CellRendererText()
        cellpb = gtk.CellRendererPixbuf()
       	tvcolumn[0] = gtk.TreeViewColumn(self.column_names[0])
       	self.treeview.append_column(tvcolumn[0])

       	tvcolumn[0].pack_start(cellpb, False)
       	tvcolumn[0].pack_start(cell, True)
       	tvcolumn[0].set_attributes(cellpb, stock_id=1)
       	tvcolumn[0].set_attributes(cell, text=0)

       	tvcolumn[0].set_resizable(True)
        for n in range (1, len(self.column_names)):
            tvcolumn[n] = gtk.TreeViewColumn(self.column_names[n])
            self.treeview.append_column(tvcolumn[n])
            tvcolumn[n].pack_start(cell1, True)
            tvcolumn[n].set_attributes(cell1, text=n+1)
            tvcolumn[n].set_resizable(True)

        self.treeview.set_expander_column(self.treeview.get_column(0))

        # create scrollbars
        scrolledwindow = gtk.ScrolledWindow()
        scrolledwindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        scrolledwindow.add(self.treeview)

        # make it searchable and connect popups
        self.treeview.set_search_column(1)
        self.treeview.connect("cursor-changed", self.select_on_click)
        self.treeview.connect("button_press_event", self.button_clicked)

        return scrolledwindow, self.treestore, self.treeview

    def __init__(self, MainWindow):
        # create a TreeStore with one string column to use as the model
        self.treestore = gtk.TreeStore(str, str, str, str)
        self.treeview = gtk.TreeView(self.treestore)
        self.mainwindow = MainWindow

