#!/usr/bin/env python

# Dialog windows

import pygtk
pygtk.require('2.0')
import gtk

import pyNeighborhood

def dialog(text, parent):
    msg = gtk.MessageDialog(parent, gtk.DIALOG_MODAL, 
                            gtk.MESSAGE_WARNING, gtk.BUTTONS_CLOSE, text)
    msg.connect("response", lambda d, r: d.destroy())
    msg.show()
    return
		
def about(parent):
    text= """pyNeighborhood 0.3\nCopyright \302\251 2005 Mykola Lynnyk Home:pyneighborhood.sourceforge.net\n\n 
Distributed under the terms of the GNU General Public License"""
    msg = gtk.MessageDialog(parent, gtk.DIALOG_MODAL |gtk.DIALOG_DESTROY_WITH_PARENT, 
								gtk.MESSAGE_INFO, gtk.BUTTONS_CLOSE, text)
    msg.connect ("response", lambda d, r: d.destroy())
    msg.show()
    return

def addmachine(parent):
    msg = gtk.Dialog("Add Machine",
                     parent,
                     gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                     (gtk.STOCK_OK, gtk.RESPONSE_OK,
                     gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
        
    vbox = gtk.VBox(True, 20)
    msg.set_resizable(False)

    entry = gtk.Entry()
    entry.set_max_length(50)
    entry.select_region(0, len(entry.get_text()))
    msg.vbox.pack_start(entry, True, True, 0)
    entry.show()

    msg.show_all()
    response = msg.run()
    if response == gtk.RESPONSE_OK: 
        text = entry.get_text()
        msg.destroy()
        return text
    if response == gtk.RESPONSE_CANCEL: 
        msg.destroy()
        return None
    msg.destroy()
			
def options(parent):
    msg = gtk.Dialog("Preferences",
                     parent,
                     gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                     (gtk.STOCK_OK, gtk.RESPONSE_OK,
                     gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
      
    vbox = gtk.VBox(True, 20)
    msg.set_resizable(False)
	
    #Mount folder
    lbl1 = gtk.Label("Mount folder (you are to have write permissions)")
    lbl1.show()
    msg.vbox.pack_start(lbl1, False, False, 4)
  
    entry1 = gtk.Entry()
    entry1.set_max_length(50)
    entry1.select_region(0, len(entry1.get_text()))
#    entry1.set_text(optlist[0])
    entry1.set_text(pyNeighborhood.parser.optdict["mount_directory"])
    msg.vbox.pack_start(entry1, True, True, 0)
    hsep1 = gtk.HSeparator()
    msg.vbox.pack_start(hsep1, True, True, 0)
    hsep1.show()
    entry1.show()

    #Mount command
    lbl2 = gtk.Label("Mount command")
    lbl2.show()
    msg.vbox.pack_start(lbl2, False, False, 4)
	
    entry2 = gtk.Entry()
    entry2.set_max_length(50)
    entry2.select_region(0, len(entry2.get_text()))
    #entry2.set_text(optlist[1])
    entry2.set_text(pyNeighborhood.parser.optdict["smb_mount"])
    msg.vbox.pack_start(entry2, True, True, 0)
    hsep2 = gtk.HSeparator()
    msg.vbox.pack_start(hsep2, True, True, 0)
    hsep2.show()
    entry2.show()

    #Mount command-line options
    lbl3 = gtk.Label("Mount command-line options")
    lbl3.show()
    msg.vbox.pack_start(lbl3, False, False, 4)
	
    entry3 = gtk.Entry()
    entry3.set_max_length(50)
    entry3.select_region(0, len(entry3.get_text()))
    entry3.set_text(pyNeighborhood.parser.optdict["smb_options"])
    #entry3.set_text(optlist[2])
    msg.vbox.pack_start(entry3, True, True, 0)
    hsep3 = gtk.HSeparator()
    msg.vbox.pack_start(hsep3, True, True, 0)
    hsep3.show()
    entry3.show()

    #File manager to launch
    lbl4 = gtk.Label("Your file manager")
    lbl4.show()
    msg.vbox.pack_start(lbl4, False, False, 4)

    entry4 = gtk.Entry()
    entry4.set_max_length(50)
    entry4.select_region(0, len(entry4.get_text()))
    #entry4.set_text(optlist[3])
    entry4.set_text(pyNeighborhood.parser.file_managers[0])
    msg.vbox.pack_start(entry4, True, True, 0)
    hsep4 = gtk.HSeparator()
    msg.vbox.pack_start(hsep4, True, True, 0)
    hsep4.show()
    entry4.show()

    #Unmount command
    lbl5 = gtk.Label("Unmount command")
    lbl5.show()
    msg.vbox.pack_start(lbl5, False, False, 4)

    entry5 = gtk.Entry()
    entry5.set_max_length(50)
    entry5.select_region(0, len(entry5.get_text()))
    #entry5.set_text(optlist[4])
    entry5.set_text(pyNeighborhood.parser.optdict["smb_umount"])
    msg.vbox.pack_start(entry5, True, True, 0)
    hsep5 = gtk.HSeparator()
    msg.vbox.pack_start(hsep5, True, True, 0)
    hsep5.show()
    entry5.show()

    #Mtab location
#    lbl6 = gtk.Label("Mtab location")
 #   lbl6.show()
#    msg.vbox.pack_start(lbl6, False, False, 4)
#
#    entry6 = gtk.Entry()
#    entry6.set_max_length(50)
#    entry6.select_region(0, len(entry6.get_text()))
#    entry6.set_text(optlist[5])
#    msg.vbox.pack_start(entry6, True, True, 0)
#    hsep6 = gtk.HSeparator()
#    msg.vbox.pack_start(hsep6, True, True, 0)
#    hsep6.show()
#    entry6.show()

    msg.show_all()
    response = msg.run()
    newoptdict = {}
    if response == gtk.RESPONSE_OK: 
        newoptdict["mount_directory"] = entry1.get_text()
        newoptdict["smb_mount"] = entry2.get_text()
        newoptdict["smb_options"] = entry3.get_text()
        newoptdict["file_managers"] = entry4.get_text()
        newoptdict["smb_umount"] = entry5.get_text()
#        newoptlist.append(entry6.get_text())
        msg.destroy()
        return newoptdict
    if response == gtk.RESPONSE_CANCEL: 
        msg.destroy()
        return None
    msg.destroy()
			
def main():	
    gtk.main()

