#!/usr/bin/env python
# -*- coding: utf8-*-

# creates a main window with basic view of a samba tree

import pygtk
pygtk.require('2.0')
import gtk
import gobject
import string
import os
import time
from os import system, getenv

import dialog
import addconfig
import config
import threads
import monitor
import bookmarks
import handlers
import pyNeighborhood

class MainWindow:

    #
    # close the window and quit
    #
    def delete_event(self):
        home = getenv("HOME")
        conflocation = string.join([home, "/.pyNeighborhood"], '')
        os.chdir(conflocation)
        gtk.main_quit()
        self.monitor_thr.quit = True
        os._exit(99)
        return False

    #
    # create a main menu
    #
    def get_main_menu(self, window):
        actions = gtk.ActionGroup("Actions")
        actions.add_actions(self.menu_entries)

        ui = gtk.UIManager()
        ui.insert_action_group(actions, 0)
        window.add_accel_group(ui.get_accel_group())
        try:
            mergeid = ui.add_ui_from_string(self.ui_info)
        except gobject.GError, msg:
            print "building menus failed: %s" % msg


        return ui
    
    #
    # global handlers
    #
    def delete_event_handler(self, widget, event, data=None):
        self.delete_event()

    def umount(self):
        #
        # It is really necessary to move this handler here -
        # because "monitor" and "bookmarks" objects are to be passed
        #
        treeselection = self.bookmarks.treeview.get_selection()
        (model, iter) = treeselection.get_selected()
        if iter != None:
            thr = threads.Umount_Thread(self.notebook, 
                                        self.treeview, 
                                        self.treestore, 
                                        self.treeview_mon, 
                                     self.treestore_mon)
            thr.start()

    #
	# handlers for running menuitems
    #
    def scan_menu_handler(self, action):
        handlers.scan(self, self)

    def remove_menu_handler(self, action):
        handlers.remove(self, self)

    def filemanager_menu_handler(self, action):
        handlers.filemanager(self, self)
    		
    def mount_menu_handler(self, action):
        handlers.mount(self, self)

    def umount_menu_handler(self, action):
        self.umount()

    def about_menu_handler(self, action):
        dialog.about(self.window)
        return
    		
    def addmach_menu_handler(self, action):
        newhost = dialog.addmachine(self.window)
        if newhost != None: 
            self.treestore.append(None, [newhost, "host", "", ""])
            addconfig.addhost(newhost)
        return

    #
    # After new interface implementing!!!!!!!!!!!!!!
    #
    def preferences_menu_handler(self, action):
        newoptdict = dialog.options(self.window)
        if newoptdict != None:
            pyNeighborhood.parser.write(newoptdict["mount_directory"], newoptdict["file_managers"], 
                                        newoptdict["smb_mount"], newoptdict["smb_umount"], newoptdict["smb_options"],
                                        "", "", "", "", "")
        return

    def quit_menu_handler(self, action):
        self.delete_event()

    #
    # constructor
    #
    def __init__(self):
        #
        # create a new window
        #
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.set_title("pyNeighborhood")
        try:
            self.window.set_icon_from_file("icons/pyneighborhood.png")
        except:
            self.window.set_icon_from_file(string.join([config.config(), '/', 'share', '/', 
                                           'pyNeighborhood', '/', 'icons', '/','pyneighborhood.png'], ''))
        self.window.set_size_request(600, 400)
        self.window.connect("delete_event", self.delete_event_handler, self.window)
        self.window.connect("destroy", self.delete_event_handler, self.window)

        #
        # create menu
        #
        self.menu_vbox = gtk.VBox(False, 1)
        self.menu_vbox.set_border_width(1)

        self.menu_entries = (
            ("FileMenu", None, "_File"),
            ("ActionMenu", None, "_Action"),
            ("EditMenu", None, "_Edit"),
            ("HelpMenu", None, "_Help"),
            ("Quit", gtk.STOCK_QUIT,
             None, "<control>Q", None,
             self.quit_menu_handler),
            ("Scan", "SCAN", 
             "_Scan", None, None,
             self.scan_menu_handler),
            ("Mount", "MOUNT", 
             "_Mount", None, None,
             self.mount_menu_handler),
            ("Unmount", "UNMOUNT", 
             "_Unmount", None, None,
             self.umount_menu_handler),
            ("FileManager","FILEMANAGER", 
             "_File Manager", None, None,
             self.filemanager_menu_handler),
            ("AddMachine", gtk.STOCK_ADD, 
             "_Add Machine...", "<control>A", None,
             self.addmach_menu_handler),
            ("Remove", gtk.STOCK_REMOVE, 
             None, "<control>R", None,
             self.remove_menu_handler),
            ("Preferences", gtk.STOCK_PREFERENCES, 
             None, None, None,
             self.preferences_menu_handler),
            ("Help", gtk.STOCK_ABOUT, 
             None, None, None,
             self.about_menu_handler)
        )

        self.ui_info = \
        """
        <ui>
          <menubar name = "MenuBar">
            <menu action = "FileMenu">
              <menuitem action = "Quit"/>
            </menu>
            <menu action = "ActionMenu">
              <menuitem action = "Scan"/>
              <menuitem action = "Mount"/>
              <menuitem action = "Unmount"/>
              <menuitem action = "FileManager"/>
            </menu>
            <menu action = "EditMenu">
              <menuitem action = "AddMachine"/>
              <menuitem action = "Remove"/>
              <menuitem action = "Preferences"/>
            </menu>
            <menu action = "HelpMenu">
              <menuitem action = "Help"/>
            </menu>
          </menubar>
        </ui>
        """
        menubar = self.get_main_menu(self.window)
        self.window.add(self.menu_vbox)
        self.menu_vbox.show()
        self.menu_vbox.pack_start(menubar.get_widget("/MenuBar"), False, False, 0)
        
        #
        # create a new notebook, place the position of the tabs
        #
        self.notebook = gtk.Notebook()
        label_1 = gtk.Label()
        label_1.set_text("Bookmarks")
        label_2 = gtk.Label()
        label_2.set_text("Mounts")
        
        #
        # vbox with notebook
        #
        # Bookmarks
        self.note_vbox = gtk.VBox(False, 1)
        self.note_vbox.set_border_width(1)
        self.note_vbox.show()

        # Mounts
        self.note_vbox_mou = gtk.VBox(False, 1)
        self.note_vbox_mou.set_border_width(1)
        self.note_vbox_mou.show()

        #
        # create "Bookmarks" and "Mounts" widgets
        #
        # create bookmarks treeview
        self.bookmarks = bookmarks.Bookmarks_Widget(self)
        self.scrolledwindow, self.treestore, self.treeview = self.bookmarks.Bookmarks()
        # create monitor treeview
        self.pyn_monitor = monitor.Monitor_Widget(self)
        self.scrolledwindow_mon, self.treestore_mon, self.treeview_mon = self.pyn_monitor.Monitor()

        #
        # add widgets to notebook
        #
        # Bookmarks
        self.note_vbox.pack_start(self.scrolledwindow, True, True, 0)
        self.notebook.append_page(self.note_vbox, label_1)

        # Mounts
        self.note_vbox_mou.pack_start(self.scrolledwindow_mon, True, True, 0)
        self.notebook.append_page(self.note_vbox_mou, label_2)

        #
        # show the notebook
        #
        self.notebook.set_show_tabs(True)
        self.notebook.show()

        #
        # start a thread with the mounts monitor
        #
        self.monitor_thr = threads.Monitor_Thread(self.treestore_mon)
        self.monitor_thr.start()

        #
        # pack everything into vbox and show all
        #

        print pyNeighborhood.parser.optdict 
        self.menu_vbox.pack_start(self.notebook, True, True, 0)
        self.window.show_all()

def main():
    gobject.threads_init()
    gtk.main()

