import os
import string
from os import system, environ, path, getenv, mkdir, getcwd

separator = " = "

class OptionsParser:
    #
    # Remove unuseful spaces
    #
    def unpad(self, str):
        if str == '':
            return str
        else:            
            splitted = str.split(" ")
            non_empty_list = []
            for sym in splitted:
                if sym == '':
                    pass
                else:
                    non_empty_list.append(sym)
            unpadded_line = string.join(non_empty_list)
            return unpadded_line

    #
    # Read a list of file managers
    #
    def read_filemanager(self):
        full_filemanager_string = self.optdict["file_managers"]
        self.file_managers = full_filemanager_string.split("|")
        return
    
    #
    # Read all the mount options
    #
#    def read_mount(self):
#        full_mount_string = self.optdict["mount_commands"]
#        mount_strings = full_mount_string.split("|")
#        for mount_sequence in mount_strings:
#            options = mount_sequence.split(":")
#            self.mount.append(options[0])
#            self.unmount.append(options[1])
#            self.mount_options.append(options[2])
#        return
      
    #
    # Parse configuration file
    #
    def read(self):
        try:
            fd = open(self.filename)
        except:
            print "error: no such file or directory - %s" % self.filename
            if os.path.exists(self.filename):
                #we talk about a file
                print "error: cannot open %s for reading" % self.filename
            return

        for line in fd.readlines():
            try:
                line = line.decode('utf-8')
            except UnicodeDecodeError:
                line = line.decode(locale.getpreferredencoding())
            index = line.find(separator)
            var_str = line[0:index]
            value_str = line[index + 3:-1]
            self.optdict[var_str] = value_str

        fd.close()
        return self.optdict
    
    #
    # Write configuration file
    #
    def write(self, mount_directory,
                    file_managers,
                    smb_mount,
                    smb_umount,
                    smb_options,
                    cifs_mount,
                    cifs_umount,
                    cifs_options,
                    user,
                    password):
        #
        # Clear the options file
        #
        fd = open(self.filename, 'w')
        fd.close()

        fd = open(self.filename, 'a')
        fd.write("mount_directory" + separator + self.unpad(mount_directory) + "\n")
        fd.write("file_managers" + separator + self.unpad(file_managers) + "\n")
        fd.write("smb_mount" + separator + self.unpad(smb_mount) + "\n")
        fd.write("smb_umount" + separator + self.unpad(smb_umount) + "\n")
        fd.write("smb_options" + separator + self.unpad(smb_options) + "\n")
        fd.write("cifs_mount" + separator + self.unpad(cifs_mount) + "\n")
        fd.write("cifs_umount" + separator + self.unpad(cifs_umount) + "\n")
        fd.write("cifs_options" + separator + self.unpad(cifs_options) + "\n")
        fd.write("user" + separator + self.unpad(user) + "\n")
        fd.write("password" + separator + self.unpad(password) + "\n")

        fd.close()
        self.read()
        self.read_filemanager()
        return

    def __init__(self, filename):
        self.filename = filename
        #
        # Dictionary holding the total list
        #
        self.optdict = {}
        self.file_managers = []
        print "Running!"
        #
        # Check if the configuartion file exists. If no, 
        # create it with default values
        #
        if not path.exists(getenv("HOME")+"/.pyNeighborhood"):
            mkdir(getenv("HOME")+"/.pyNeighborhood")
            home = getenv("HOME")
            hostslocation = string.join([home, "/.pyNeighborhood"], '')
            os.chdir(hostslocation)
            self.write("/mnt/lan", "xterm -e", 
                       "smbmount", "smbumount:", "", 
                       "mount.cifs", "umount.cifs", "",
                       "/etc", "", "")

        try: 
            fd = open(self.filename, "r")
        except: 
            self.write("/mnt/lan", "xterm -e", 
                       "smbmount", "smbumount", "", 
                       "mount.cifs", "umount.cifs", "",
                       "", "")

        #
        # Necessary to run with constructor
        #
        self.read()
#        self.read_mount()
        self.read_filemanager()

        # remove this
        print self.optdict
        print self.file_managers


if __name__=="__main__":
    parser = OptionsParser("/home/cthulhu/.pyNeighborhood/options.conf")

