#!/usr/bin/env python

#Threads

import threading
import gobject 
import string
import time
import thread
from os import system, getenv

import getsmbshare
import checkmount
import sharmount
import readconfig
import pyNeighborhood
import dialog

class Monitor_Thread(threading.Thread):
    def __init__(self, treestore):
        self.treestore = treestore
        super(Monitor_Thread, self).__init__()
        self.quit = False
        return 

    def monitor_handler(self):
        i=0
        resource = []
        hosts, shares , mount_points = checkmount.checkmount()
        if self.hosts_old != hosts and self.shares_old != shares:
            self.treestore.clear()
            for host in hosts:
                resource.append(string.join(["/", host, shares[i]], '/'))
                iter = self.treestore.append(None, None)
                self.treestore.set(iter, 0, resource[i])
                self.treestore.set(iter, 1, mount_points[i])
                i = i+1
            self.hosts_old = hosts
            self.shares_old = shares
        return

    def run(self):
        self.hosts_old = []
        self.shares_old= []
        while not self.quit:
            gobject.idle_add(self.monitor_handler)
            time.sleep(2)
        return

class Append_Thread(threading.Thread):
    def __init__(self, treeview,  path, column, treestore):
        self.treeview = treeview
        self.path = path
        self.column = column
        self.treestore = treestore

        self.id = threading._get_ident()
        self.model = treeview.get_model()
        self.iter = self.model.get_iter(path)
        self.current_host = self.model.get_value(self.iter, 0)
        #cur_host_prev = current_host

        super(Append_Thread, self).__init__()
        #self._finished = threading.Event()

    def appendshar(self, treeview,  path, column, treestore):
        #get some necessary info 
        model = self.model
        iter = self.iter
        current_host = self.current_host
        cur_host_prev = current_host
        #get a list of shares with comments
        (hosts, shares, mount_points) = checkmount.checkmount()
        (hostsharlist, commentlist) = (self.hostsharlist, self.commentlist)
        if hostsharlist == 0:
            #print commentlist
            #thread.exit()
            return False

        i = 0
        #check whether we are trying to scan a last share
        if model.iter_next(iter) == None:
            useiter = None
        else:
            useiter = iter

        treestore.remove(iter)
        newiter = treestore.insert_before(None, useiter, [current_host, "host", "", ""])
        for child in hostsharlist:
            temiter = treestore.append(newiter, [hostsharlist[i], "share", commentlist[i], ""])
            for num in hosts:
                if num == cur_host_prev:
                    k = 0
                    for num1 in shares:
                        if shares[k] == hostsharlist[i] and hosts[k] == cur_host_prev: 
                            treestore.set_value(temiter, 3, mount_points[k])
                        k = k+ 1
            i = i+1

        treeview.expand_row(path, True)
        #thread.exit_thread()
        return False

    def run(self):
        (self.hostsharlist, self.commentlist) = getsmbshare.getsmbshare(self.current_host, self.id)
        gobject.idle_add(self.appendshar, self.treeview,  self.path, self.column, self.treestore)
        return

class Mount_Thread(threading.Thread):
    def __init__(self, treeview,  path, column, treestore, notebook):
        self.treestore = treestore
        self.treeview = treeview
        self.path = path
        self.column = column
        self.notebook = notebook

        super(Mount_Thread, self).__init__()
        self.quit = False
        self.flag_exit = 1

    def mountshar(self, treestore):
        f_thread = Fmanager_Thread(self.notebook, self.treeview)
        f_thread.start()
        treestore.set(self.iter, 3, self.mount_point)
        return

    def run(self):
        hostflag1=0
        hostflag2=0
        hostflag3=0

        #get a share properties		
        model = self.treeview.get_model()
        self.iter = model.get_iter(self.path)
        self.current_host = model.get_value(self.iter, 0)
        par_iter = model.iter_parent(self.iter)
        self.h_name = model.get_value(par_iter, 0)

        #resolve mountpoint
        self.mount_dir = pyNeighborhood.parser.optdict["mount_directory"]

        self.mount_point = string.join([self.mount_dir, "/" ,self.h_name , "/" , self.current_host], '')
	
        (hosts, shares, mount_points) = checkmount.checkmount()
        flag = 0
        for num in hosts:
            if num == self.h_name: hostflag1 = 1
        for num in shares:
            if num == self.current_host: hostflag2 = 1
        for num in mount_points:
            if num == self.mount_point: hostflag3 = 1
        if hostflag3==1:
            print "Mount point already in use!!!"
            gobject.idle_add(dialog.dialog,"Mount point already in use.", None)
            self.flag_exit = 0
            flag = 1
            #return
        if hostflag1==1 and hostflag2==1 and flag == 0:
            print "According to mtab already mounted!!!"
            gobject.idle_add(dialog.dialog,"According to mtab already mounted.", None)
            self.flag_exit = 0
            #return
        if self.flag_exit != 0:
            sharmount.sharmount(self.h_name, self.current_host)
            gobject.idle_add(self.mountshar, self.treestore)
				

class Umount_Thread(threading.Thread):
    def __init__(self, notebook, treeview, treestore, treeview_mon, treestore_mon):
        self.notebook = notebook
        self.treestore = treestore
        self.treestore_mon = treestore_mon
        self.treeview = treeview
        self.treeview_mon = treeview_mon

        super(Umount_Thread, self).__init__()
        return 

    def run(self):
        notebook = self.notebook
        treestore = self.treestore
        treestore_mon = self.treestore_mon
        treeview =self.treeview
        treeview_mon = self.treeview_mon
        page = notebook.get_current_page()
        if page == 0:
            treeselection = treeview.get_selection()
            (model, iter) = treeselection.get_selected()
            par_iter = model.iter_parent(iter)
            if not par_iter == None:
                h_name = model.get_value(iter, 3)
                flag = sharmount.sharumount(h_name)
                if flag == True: gobject.idle_add(treestore.set, iter, 3, '')
                else: 
                    print "Could not unmount current share"
                    gobject.idle_add(dialog.dialog,"Could not unmount current share.", None)

            else: print "Probably not smb-filesystem "
            return
        if page == 1:
            treeselection = treeview_mon.get_selection()
            (model, iter) = treeselection.get_selected()
            try:
                host_share = model.get_value(iter, 0)
            except:
                return
            mountpoint = model.get_value(iter, 1)
            line = host_share.split('/')
            flag = sharmount.sharumount(mountpoint)
            if flag == True: 
                gobject.idle_add(treestore_mon.remove, iter)

                try:
                    hostlist = readconfig.readconfig()
                    n = 0
                    k = 0
                    for host in hostlist:
                        iter = treestore.get_iter((n, ))
                        value = treestore.get_value(iter, 0)
                        n = n+1
                        if value == line[2]:
                            break
                        value_sh = ''
                    while 1:
                        iter_sh = treestore.get_iter((n-1, k))
                        value_sh = treestore.get_value(iter_sh, 0)
                        k = k + 1
                        if value_sh == line[3]:
                            break
                    gobject.idle_add(treestore.set,iter_sh, 3, '')
                except:
                    return
            else:
                print "Could not unmount current share"
                gobject.idle_add(dialog.dialog,"Could not unmount current share.", None)
            return
        return

class Fmanager_Thread(threading.Thread):
    def __init__(self, notebook, treeview):
        self.notebook = notebook
        self.treeview = treeview

        super(Fmanager_Thread, self).__init__()
        return 

    def filemanager(self, notebook, treeview):
        page = notebook.get_current_page()
        treeselection = treeview.get_selection()
        (model, iter) = treeselection.get_selected()
        if page == 0:
            par_iter = model.iter_parent(iter)
            if not par_iter == None:
                h_name = model.get_value(iter, 3)
                sharmount.file_mng(h_name)
            return
        if page == 1:
            try:
                mountpoint = model.get_value(iter, 1)
            except:
                return
            sharmount.file_mng(mountpoint)
        return
		
    def run(self):
        self.filemanager(self.notebook, self.treeview)
        return

